/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 31/10/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;
import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.*;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.EnumAlamat;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.AlamatId;

import org.hibernate.annotations.Type;

@Entity
@Table(name = "Alamat_M", indexes = { @Index(name = "Alamat_M_Index", columnList = "statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class Alamat {

	@EmbeddedId
	private AlamatId id;

	private static final String cDefKdJenisAlamat = INTEGER;
	@Column(name = "KdJenisAlamat", columnDefinition = cDefKdJenisAlamat)
	@NotNull(message = "alamat.kdjenisalamat.notnull")
	private Integer kdJenisAlamat;

	

	private static final String cDefAlamatLengkap = VARCHAR + AWAL_KURUNG + 200 + AKHIR_KURUNG;
	@Column(name = "AlamatLengkap", columnDefinition = cDefAlamatLengkap)
	@NotNull(message = "alamat.alamatlengkap.notnull")
	private String alamatLengkap;

	private static final String cDefKdDesaKelurahan = INTEGER;
	@Column(name = "KdDesaKelurahan", columnDefinition = cDefKdDesaKelurahan)
	private Integer kdDesaKelurahan;


	private static final String cDefRTRW = VARCHAR + AWAL_KURUNG + 7 + AKHIR_KURUNG;
	@Column(name = "RTRW", columnDefinition = cDefRTRW)
	private String rTRW;

	private static final String cDefKdKecamatan = INTEGER;
	@Column(name = "KdKecamatan", columnDefinition = cDefKdKecamatan)
	private Integer kdKecamatan;



	private static final String cDefKdKotaKabupaten = INTEGER;
	@Column(name = "KdKotaKabupaten", columnDefinition = cDefKdKotaKabupaten)
	private Integer kdKotaKabupaten;

	

	private static final String cDefKdPropinsi = INTEGER;
	@Column(name = "KdPropinsi", columnDefinition = cDefKdPropinsi)
	//@NotNull(message = "alamat.kdpropinsi.notnull")
	private Integer kdPropinsi;

	private static final String cDefKodePos = VARCHAR + AWAL_KURUNG + 10 + AKHIR_KURUNG;
	@Column(name = "KodePos", columnDefinition = cDefKodePos)
	private String kodePos;

	private static final String cDefKdNegara = INTEGER;
	@Column(name = "KdNegara", columnDefinition = cDefKdNegara)
	@NotNull(message = "alamat.kdnegara.notnull")
	private Integer kdNegara;

	private static final String cDefFixedPhone1 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "FixedPhone1", columnDefinition = cDefFixedPhone1)
	private String fixedPhone1;

	private static final String cDefFixedPhone2 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "FixedPhone2", columnDefinition = cDefFixedPhone2)
	private String fixedPhone2;

	private static final String cDefMobilePhone1 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "MobilePhone1", columnDefinition = cDefMobilePhone1)
	private String mobilePhone1;

	private static final String cDefMobilePhone2 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "MobilePhone2", columnDefinition = cDefMobilePhone2)
	private String mobilePhone2;

	private static final String cDefFaksimile1 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "Faksimile1", columnDefinition = cDefFaksimile1)
	private String faksimile1;

	private static final String cDefFaksimile2 = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "Faksimile2", columnDefinition = cDefFaksimile2)
	private String faksimile2;

	private static final String cDefAlamatEmail = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG;
	@Column(name = "AlamatEmail", columnDefinition = cDefAlamatEmail)
	private String alamatEmail;

	private static final String cDefWebsite = VARCHAR + AWAL_KURUNG + 80 + AKHIR_KURUNG;
	@Column(name = "Website", columnDefinition = cDefWebsite)
	private String website;

	private static final String cDefBlackBerry = VARCHAR + AWAL_KURUNG + 10 + AKHIR_KURUNG;
	@Column(name = "BlackBerry", columnDefinition = cDefBlackBerry)
	private String blackBerry;

	private static final String cDefWhatsApp = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "WhatsApp", columnDefinition = cDefWhatsApp)
	private String whatsApp;

	private static final String cDefYahooMessenger = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG;
	@Column(name = "YahooMessenger", columnDefinition = cDefYahooMessenger)
	private String yahooMessenger;

	private static final String cDefTwitter = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG;
	@Column(name = "Twitter", columnDefinition = cDefTwitter)
	private String twitter;

	private static final String cDefFacebook = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG;
	@Column(name = "Facebook", columnDefinition = cDefFacebook)
	private String facebook;

	private static final String cDefLine = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG;
	@Column(name = "Line", columnDefinition = cDefLine)
	private String line;

	private static final String cDefisPrimaryAddress = INTEGER;
	@Column(name = "isPrimaryAddress", columnDefinition = cDefisPrimaryAddress)
	@NotNull(message = "alamat.isprimaryaddress.notnull")
	private Integer isPrimaryAddress;

	private static final String cDefisShippingAddress = INTEGER;
	@Column(name = "isShippingAddress", columnDefinition = cDefisShippingAddress)
	@NotNull(message = "alamat.isshippingaddress.notnull")
	private Integer isShippingAddress;

	private static final String cDefisBillingAddress = INTEGER;
	@Column(name = "isBillingAddress", columnDefinition = cDefisBillingAddress)
	@NotNull(message = "alamat.isbillingaddress.notnull")
	private Integer isBillingAddress;

	private static final String cDefNoCM = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "NoCM", columnDefinition = cDefNoCM)
	private String noCM;

	private static final String cDefKdPegawai = VARCHAR + AWAL_KURUNG + 5 + AKHIR_KURUNG;
	@Column(name = "KdPegawai", columnDefinition = cDefKdPegawai)
	private String kdPegawai;
	
	private static final String cDefKdPerson = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "KdPerson", columnDefinition = cDefKdPerson)
	private String kdPerson;

	private static final String cDefKdHubunganKeluarga = INTEGER;
	@Column(name = "KdHubunganKeluarga", columnDefinition = cDefKdHubunganKeluarga)
	private Integer kdHubunganKeluarga;

	private static final String cDefKdRekanan = INTEGER;
	@Column(name = "KdRekanan", columnDefinition = cDefKdRekanan)
	private Integer kdRekanan;

	private static final String cDefKdBankAccount = INTEGER;
	@Column(name = "KdBankAccount", columnDefinition = cDefKdBankAccount)
	private Integer kdBankAccount;

	private static final String cDefGarisLintangLatitude = FLOAT;
	@Column(name = "GarisLintangLatitude", columnDefinition = cDefGarisLintangLatitude)
	private Float garisLintangLatitude;

	private static final String cDefGarisBujurLongitude = FLOAT;
	@Column(name = "GarisBujurLongitude", columnDefinition = cDefGarisBujurLongitude)
	private Float garisBujurLongitude;

	private static final String cDefRadiusAlamat = FLOAT;
	@Column(name = "RadiusAlamat", columnDefinition = cDefRadiusAlamat)
	private Float radiusAlamat;

	private static final String cDefKeteranganLainnya = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG;
	@Column(name = "KeteranganLainnya", columnDefinition = cDefKeteranganLainnya)
	private String keteranganLainnya;

	private static final String cDefTglDaftar = INTEGER;
	@Column(name = "TglDaftar", columnDefinition = cDefTglDaftar)
	private Long tglDaftar;

	private static final String cDefStatusEnabled = INTEGER;
	@Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
	@Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;

	private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG;
	@Column(name = "NoRec", columnDefinition = cDefNoRec)
	@NotNull(message = "alamat.norec.notnull")
	private String noRec;

	private static final String cDefVersion = INTEGER;
	@Version
	@Column(name = "version", nullable = false, columnDefinition = cDefVersion)
	@NotNull(message = "alamat.version.notnull")
	private Integer version;
	
	private static final String cDefEnumAlamat = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "EnumAlamat", nullable = false, columnDefinition = cDefEnumAlamat)
	@NotNull(message = "alamat.enumAlamat.notnull")
	private String enumAlamat;

	
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Profile profile;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdJenisAlamat", referencedColumnName = "KdJenisAlamat", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private JenisAlamat jenisAlamat;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdNegara", referencedColumnName = "KdNegara", insertable = false, updatable = false),
			@JoinColumn(name = "KdDesaKelurahan", referencedColumnName = "KdDesaKelurahan", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private DesaKelurahan desaKelurahan;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdNegara", referencedColumnName = "KdNegara", insertable = false, updatable = false),
			@JoinColumn(name = "KdKecamatan", referencedColumnName = "KdKecamatan", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Kecamatan kecamatan;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdNegara", referencedColumnName = "KdNegara", insertable = false, updatable = false),
			@JoinColumn(name = "KdKotaKabupaten", referencedColumnName = "KdKotaKabupaten", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private KotaKabupaten kotaKabupaten;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdNegara", referencedColumnName = "KdNegara", insertable = false, updatable = false),
			@JoinColumn(name = "KdPropinsi", referencedColumnName = "KdPropinsi", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Propinsi propinsi;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
		 	@JoinColumn(name = "KdNegara", referencedColumnName = "KdNegara", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Negara negara;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdPegawai", referencedColumnName = "KdPegawai", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Pegawai pegawai;
	
//	@ManyToOne(fetch = FetchType.LAZY)
//	@JsonIgnore
//	@JoinColumns({
//			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
//			@JoinColumn(name = "KdPerson", referencedColumnName = "KdPerson", insertable = false, updatable = false), })
//	//@ForeignKey(name="none")
//	private Person person;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdHubunganKeluarga", referencedColumnName = "KdHubunganKeluarga", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private HubunganKeluarga hubunganKeluarga;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdRekanan", referencedColumnName = "KdRekanan", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private Rekanan rekanan;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdBankAccount", referencedColumnName = "KdBankAccount", insertable = false, updatable = false), })
	//@ForeignKey(name="none")
	private BankAccount bankAccount;




	
}